#include <sgjbase.h>
int i2(int i, int j, int n1){
  int ij;
  ij=i*n1+j;
  return ij;
}
 
int i3(int i, int j, int k, int *n){
  int ijk;
  ijk=i*n[0]+j*n[1]+k;
  return ijk;
/*
   n[1]=n_k*n_j; n[2]=n_k
*/  
}

void d3( int n2,int n3,int *n){
  n[0]=n2*n3; n[1]=n3;
}


int i4(int i, int j, int k, int l, int *n){
  int ijkl;
  ijkl=i*n[0]+j*n[1]+k*n[2]+l;
  return ijkl;
 /*
    n[1]=n_j*n_k*n_l; n[2]=n_k*n_l; n[3]=n_l
  */
}

void d4(int n2,int n3,int n4,int*n){
  n[0]=n2*n3*n4; n[1]=n3*n4; n[2]=n4;
}

int i5(int i, int j, int k, int l, int m, int *n){
  int ijklm;
  ijklm=i*n[0]+j*n[1]+k*n[2]+l*n[3]+m;
  return ijklm;
}

void d5(int n2,int n3,int n4,int n5,int *n){
  n[0]=n2*n3*n4*n5; n[1]=n3*n4*n5; n[2]=n4*n5; n[3]=n5;
}

int i6(int i, int j, int k, int l, int m, int p, int *n){
  int ijklmp;
  ijklmp=i*n[0]+j*n[1]+k*n[2]+l*n[3]+m*n[4]+p;
  return ijklmp;
}


void d6(int n2,int n3,int n4,int n5,int n6, int *n){
  n[0]=n2*n3*n4*n5*n6; n[1]=n3*n4*n5*n6; n[2]=n4*n5*n6; 
  n[3]=n5*n6; n[4]=n6;
}


int* allocatei(int n){
  int *p=(int *)malloc(n*sizeof(int));
  return p;
}
float * allocatef(int n){
  float *p=(float *)malloc(n*sizeof(float));
  return p;
}
__complex__ float* allocatec(int n){
  __complex__ float *p;
  p=(__complex__ float *)malloc(n*sizeof(__complex__ float));
  return p;
}

void deallocate(void *p){
  free(p);
}

void rowf( float *a,float *rowofa,int iy, int nx, int forward)
{
  int ix;
  if (forward){
    for(ix=0;ix<nx; ix++)
      rowofa[ix]=a[i2(iy,ix,nx)];
  }
  else{
    for(ix=0;ix<nx; ix++)
      a[i2(iy,ix,nx)]=rowofa[ix];
  }
}

void rowc(__complex__ float *a,__complex__ float *rowofa,int iy, int nx,int forward)
{
  int ix;
  if (forward){
    for(ix=0;ix<nx; ix++)
      rowofa[ix]=a[i2(iy,ix,nx)];
  }
  else{
    for(ix=0;ix<nx; ix++)
      a[i2(iy,ix,nx)]=rowofa[ix];
  }
}
void colc(__complex__ float *a,__complex__ float *rowofa,int ix, int nx,int ny,int forward)
{
  int iy;
  if (forward){
    for(iy=0;iy<ny; iy++)
      rowofa[iy]=a[i2(iy,ix,nx)];
  }
  else{
    for(iy=0;iy<ny; iy++)
      a[i2(iy,ix,nx)]=rowofa[iy];
  }
}

void rowi( int *a,int *rowofa,int iy, int nx,int forward)
{
  int ix;
  if (forward){
    for(ix=0;ix<nx; ix++)
      rowofa[ix]=a[i2(iy,ix,nx)];
  }
  else{
    for(ix=0;ix<nx; ix++)
      a[i2(iy,ix,nx)]=rowofa[ix];
  }

}

float maxval( float *a, int nx){
 float mxval;
 int ix;
 for(ix=0,mxval=a[0];ix<nx;ix++){
   if ( a[ix] > mxval) mxval=a[ix];
 }
 return mxval;
}

float maxvalc(__complex__ float *a,int nx){
 float mxval;
 int ix;
 for(ix=0,mxval=fabs(real(a[0]));ix<nx;ix++){
   if ( fabs(real(a[ix])) > mxval) mxval=fabs(real(a[ix]));
 }
 return mxval;
}

float minval( float *a,int nx){
  float mnval;
  int ix;
  for(ix=0,mnval=a[0]; ix<nx; ix++){
     if (a[ix] <mnval) mnval=a[ix];
  }
  return mnval;
}

void matrix_equ_c(__complex__ float *a,__complex__ float *b,int ny,int nx){
  // a(ny,nx) b(ny,nx)
  int iy,ix;
  for(iy=0;iy<ny;iy++)
    for(ix=0;ix<nx;ix++)
       a[i2(iy,ix,nx)]=b[i2(iy,ix,nx)];
}

void vector_value_f(float *a, float value,int nx){
  int i;
  for (i=0;i<nx;i++)
    a[i]=value;
}

void vector_value_c(__complex__ float *a,__complex__ float value,int nx){
  int i;
  for (i=0;i<nx;i++)
    a[i]=value;
}
void vector_cp_c(__complex__ float *a, __complex__ float *b, int nx){
  int i;
  for(i=0;i<nx;i++) a[i]=b[i];
}

void vector_cp_f(float *a, float *b, int nx){
  int i;
  for(i=0;i<nx;i++) a[i]=b[i];
}
