#include "sgjbase.h"
#include "math.h"
void sinc_mksinc (float d, int lsinc, float sinc[])
{
	int j;
	double s[20],a[20],c[20],work[20],fmax;
        
	/* compute auto-correlation and cross-correlation arrays */
	fmax = 0.066+0.265*log((double)(lsinc));
	fmax = (fmax<1.0)?fmax:1.0;
	for (j=0; j<lsinc; j++) {
		a[j] = dsinc(fmax*j);
		c[j] = dsinc(fmax*(lsinc/2-j-1+d));
	}
	/* solve symmetric Toeplitz system for the sinc approximation */
	stoepd(lsinc,a,c,s,work);
	for (j=0; j<lsinc; j++)
		sinc[j] = s[j];
}

double dsinc (double x)
{ double pi=3.1415926;
  double  pix;
    if (x==0.0) return 1.0;
    else {
      pix = pi*x;
      return sin(pix)/pix;
    }
}
