#include <math.h>
#include "sgjbase.h"
#include "sgjmig.h"

void dph_old(float phi,float ep,float dl,float w_vp,float f,float dkx,float dz,int m,__complex__ float *dpp,int weitm)
{
  // dpp(m)
  float kx;
  int im;
  for(im=0;im<m;im++){  //do im=1,m
    kx=im*dkx;
    dpp[im]=dphase(phi,ep,dl,w_vp,f,kx,dz);
  }
  for (im=weitm+1; im <m; im++) //do im=1,m  ?????????? wait
    dpp[im]*=0.001;
}


int weit_old(float phi,float ep,float dl,float w_vp,float f,float dkx,int m)
{
  int weitm,im;
  __complex__ float  kz1,kzp1;
  float kx,weight;

  for (im=0; im <m; im++){
     kx=im*dkx;
     kz1=kzani(phi,ep,dl,w_vp,f,-kx);
     kzp1=kzani(phi,ep,dl,w_vp,f,kx);
     if ( fabs(aimag(kz1)) <0.0000001*fabs(real(kz1)) &&  fabs(aimag(kzp1)) <0.0000001*fabs(real(kzp1))){
       if (real(kz1) >w_vp*0.0 && real(kzp1) >w_vp*0.0  )
         weight=1.00;
       else
         weight=0.001;
     }
     else
       weight=0.001;
     if (weight!=1.0){
       weitm=im-2;
       break;
     }
  }

  if (phi==0.0) weitm-=2;
  return weitm;
}


void explicit_table_old(__complex__ float *contablepp,__complex__ float *contablepm,
                    float phi,float f,float dx,float dkx,float dz, int m,int n,
                    float o_ep,float d_ep,int n_ep,float o_dl,float d_dl,int n_dl,float o_w_vp,float d_w_vp,int n_w_vp)
{  //contablepp(n_w_vp,n_ep,n_dl,n), contablepm(n_w_vp,n_ep,n_dl,n)
__complex__ float *conapp,*conapm,*dppc,*dpps;
float *qc_table,*rc_table,*qs_table,*rs_table;
float *qc,*rc,*qs,*rs;
float w_vp,ep,dl;
int *weitm,nweit,theweitm,iweit;
int im,in,i_w_vp,i_ep,i_dl;
int nqc[2],nrc[2],nqs[2],nrs[2],nconp[3];
int i;
d3(m,n,nqc); d3(n,n,nrc); d3(m-1,n-1,nqs); d3(n-1,n-1,nrs); d4(n_ep,n_dl,n,nconp);
weitm=allocatei(m);
nweit=weitmlist_old(weitm,phi,dkx,f,m,o_ep,d_ep,n_ep,o_dl,d_dl,n_dl,o_w_vp,d_w_vp,n_w_vp);
conapp=allocatec(n); conapm=allocatec(n); dppc=allocatec(m); dpps=allocatec(m);
qc_table=allocatef(nweit*m*n); 
rc_table=allocatef(nweit*n*n); 
qs_table=allocatef(nweit*(m-1)*(n-1) ); rs_table=allocatef(nweit*(n-1)*(n-1));
qc=allocatef(m*n); rc=allocatef(n*n); qs=allocatef((m-1)*(n-1)); rs=allocatef((n-1)*(n-1));
ani_init(dx,dkx,m,n,nweit,weitm,qc_table,rc_table,qs_table,rs_table);
for(i_w_vp=0;i_w_vp<n_w_vp; i_w_vp++){  //do i_w_vp=1,n_w_vp
  w_vp=o_w_vp+i_w_vp*d_w_vp;
  for(i_ep=0;i_ep<n_ep;i_ep++){//do i_ep=1,n_ep
    ep=i_ep*d_ep+o_ep;
    for(i_dl=0;i_dl<n_dl;i_dl++){ //do i_dl=1,n_dl
      dl=i_dl*d_dl+o_dl;
      theweitm=weit_old(phi,ep,dl,w_vp,f,dkx,m); 
      if (0==theweitm) theweitm=1;
      dph_old(phi,ep,dl,w_vp,f,dkx,dz,m,dppc,theweitm);  //call dph(phi,ep,dl,w_vp,f,0.0,dkx,dz,m,dppc,dpmc)
      dph_old(phi,ep,dl,w_vp,f,-dkx,dz,m,dpps,theweitm); //call dph(phi,ep,dl,w_vp,f,0.0,-dkx,dz,m,dpps,dpms) 

      for(iweit=0;iweit<nweit;iweit++){
        if(theweitm==weitm[iweit]) break;
      }
      for(im=0;im<m;im++)
        for(in=0;in<n;in++)
          qc[i2(im,in,n)]=qc_table[i3(iweit,im,in,nqc)];     //qc(:,:)=qc_table(iweit,:,:);
      for(im=0;im<n;im++)
        for(in=0;in<n;in++)
          rc[i2(im,in,n)]=rc_table[i3(iweit,im,in,nrc)];    //  rc(:,:)=rc_table(iweit,:,:);
      for(im=0;im<m-1;im++)
        for(in=0;in<n-1;in++)
          qs[i2(im,in,n-1)]=qs_table[i3(iweit,im,in,nqs)];     //qs(:,:)=qs_table(iweit,:,:);
      for(im=0;im<n-1;im++)
        for(in=0;in<n-1;in++)
          rs[i2(im,in,n-1)]=rs_table[i3(iweit,im,in,nrs)];   //rs(:,:)=rs_table(iweit,:,:);
      convlv_coe(m,n,conapp,conapm,dppc,dpps,qc,rc,qs,rs);
      
      for(in=0;in<n;in++){
        contablepp[i4(i_w_vp,i_ep,i_dl,in,nconp)]=conapp[in];  //contablepp(:,i_dl,i_ep,i_w_vp)=conapp(:)
        contablepm[i4(i_w_vp,i_ep,i_dl,in,nconp)]=conapm[in];  //contablepm(:,i_dl,i_ep,i_w_vp)=conapm(:)
      }
    }
  }
}
free(conapp); free(conapm); 
free(dppc); free(dpps);
free(qc_table); free(rc_table); 
free(qs_table); free(rs_table);
free(qc);free(rc);free(qs);free(rs);
free(weitm);
}





int weitmlist_old(int *weitm,float phi,float dkx,float f,int m,
             float o_ep,float d_ep,int n_ep,float o_dl,float d_dl,int n_dl,float o_w_vp,float d_w_vp,int n_w_vp)
{
  int i_w_vp, i_ep,i_dl;
  float w_vp,ep,dl;
  int theweitm;
  int *weitm_tmp;
  int nweit,iweit;
  nweit=m-1;
  for(iweit=0;iweit<nweit;iweit++)
    weitm[iweit]=iweit+1;
  return nweit;
}

