#include <sgjbase.h>
void fftshift(__complex__ float *a,int n)
{
  __complex__ float tmp;
  int n0=(n+1)/2;
  int i;
  for (i=0;i<n0;i++){
    tmp=a[i];
    a[i]=a[n0+i];
    a[n0+i]=tmp;

  }
}




void cwpfft(void *fz, int n, int isign)
{ 
  register int i; 
  register float  scale;
  float  *fp  = (float *)fz; 
  __complex__ float *cz = (__complex__ float *)fz;

  pfacc(isign, n, cz);

  if( isign < 0 ) {
    scale = 1.0/(float)(n); 
    for(i=0; i < 2*n; i++) 
    {
       *fp *= scale; fp++;
    }
  }
}

void  cwpfft1d(__complex__ float *a,int n,int inv)
{
  if(inv==-1){
    fftshift(a,n);
    cwpfft(a,n,-1);
  }
  else{
    cwpfft(a,n,1);
    fftshift(a,n);
  }
}      

int fftn(int nmin)
{
   return npfao(nmin,nmin+50);
}
